SystemOrganization addCategory: #'Magritte-Seaside-Basic'!
SystemOrganization addCategory: #'Magritte-Seaside-Decorations'!
SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Report'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!

!MAMultipleOptionDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 9/13/2005 09:33'!
defaultComponentClasses
	^ Array with: MAListCompositonComponent with: MACheckboxGroupComponent.! !

!MASingleOptionDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 9/13/2005 09:33'!
defaultComponentClasses
	^ Array with: MASelectListComponent with: MARadioGroupComponent.! !

Object subclass: #MAColumn
	instanceVariableNames: 'report properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MAColumn subclass: #MAActionColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultTitle
	^ String new.! !

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultUseLinks
	^ true! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 19:58'!
renderCellContent: anObject on: html
	self useLinks 
		ifTrue: [ self renderCellLinkContent: anObject on: html ]
		ifFalse: [ self renderCellFormContent: anObject on: html ].! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 19:59'!
renderCellFormContent: anObject on: html
	self subclassResponsibility.! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 19:59'!
renderCellLinkContent: anObject  on: html
	self subclassResponsibility.! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
useLinks
	^ self propertyAt: #useLinks ifAbsent: [ self defaultUseLinks ].! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
useLinks: aBoolean
	self propertyAt: #useLinks put: aBoolean.! !

MAActionColumn subclass: #MACommandColumn
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACommandColumn methodsFor: 'actions' stamp: 'lr 6/15/2005 20:48'!
addCommandOn: anObject selector: aSelector
	self addCommandOn: anObject selector: aSelector text: aSelector allButLast asCapitalizedPhrase.! !

!MACommandColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
addCommandOn: anObject selector: aSelector text: aString
	self addCommand: (MessageSend receiver: anObject selector: aSelector) text: aString.! !

!MACommandColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
addCommand: aBlock text: aString
	self commands add: aBlock -> aString.! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
commands
	^ commands! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
commands: aCollection
	commands := aCollection! !

!MACommandColumn methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
initialize
	super initialize.
	self commands: OrderedCollection new.! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 20:02'!
renderCellFormContent: anObject on: html
	self commands
		do: [ :each |
			html
				submitButtonWithAction: [ each key value: anObject ] 
				text: each value ]
		separatedBy: [ html space ].! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 20:02'!
renderCellLinkContent: anObject on: html
	self commands
		do: [ :each | 
			html 
				anchorWithAction: [ each key value: anObject ] 
				text: each value ]
		separatedBy: [ html space ].! !

MAActionColumn subclass: #MASelectionColumn
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MASelectionColumn subclass: #MACheckboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultFormDeselected
	^ ScriptingSystem formAtKey: #CheckBoxOff.! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultFormSelected
	^ ScriptingSystem formAtKey: #CheckBoxOn.! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultSelection
	^ Set new.! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
deselect: anObject
	self selection remove: anObject ifAbsent: nil.! !

!MACheckboxColumn methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isSelected: anObject
	^ self selection includes: anObject.! !

!MACheckboxColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 20:02'!
renderCellFormContent: anObject on: html
	html 
		checkboxWithValue: (self isSelected: anObject) 
		callback: [ :value | self select: anObject value: value ].! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
select: anObject
	self selection add: anObject.! !

MASelectionColumn subclass: #MAOptionboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:31'!
defaultFormDeselected
	^ ScriptingSystem formDictionary  formAtKey: #RadioButtonOff.! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:31'!
defaultFormSelected
	^ ScriptingSystem formAtKey: #RadioButtonOn.! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:31'!
defaultSelection
	^ nil! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
deselect: anObject
	self selection: nil.! !

!MAOptionboxColumn methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSelected: anObject
	^ self selection == anObject.! !

!MAOptionboxColumn methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
radioGroupFor: html
	"This is a very bad thing, you might never have seen in your own life. Very strange things might happen here, but for now it mostly does what we need."
	
	| renderer |
	renderer := self propertyAt: #radioGroupRenderer ifAbsentPut: nil.
	^ renderer == html 
		ifTrue: [ self propertyAt: #radioGroupCallback ]
		ifFalse: [
			self propertyAt: #radioGroupRenderer put: html.
			self propertyAt: #radioGroupCallback put: html radioGroup ].! !

!MAOptionboxColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 20:02'!
renderCellFormContent: anObject on: html
	html
		radioButtonInGroup: (self radioGroupFor: html) 
		selected: (self isSelected: anObject) 
		callback: [ self select: anObject ].! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
select: anObject
	self selection: anObject.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultFormDeselected
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultFormSelected
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultSelection
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
deselect: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
formDeselected
	^ self propertyAt: #formDeselected ifAbsent: [ self defaultFormDeselected ].! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
formDeselected: aForm
	^ self propertyAt: #formDeselected put: aForm.! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
formSelected
	^ self propertyAt: #formSelected ifAbsent: [ self defaultFormSelected ].! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
formSelected: aForm
	^ self propertyAt: #formSelected put: aForm.! !

!MASelectionColumn methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
isSelected: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
refresh
	super refresh.
	self selection: self defaultSelection.! !

!MASelectionColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 19:59'!
renderCellLinkContent: anObject on: html
	| selected |
	selected := self isSelected: anObject.
	html
		anchorWithAction: [ self select: anObject value: selected not ]
		do: [ 
			html imageWithForm: (selected
				ifTrue: [ self formSelected ]
				ifFalse: [ self formDeselected ]) ].! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
selection
	selection isNil
		ifTrue: [ self selection: self defaultSelection ].
	^ selection.! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
selection: anObject
	selection := anObject! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
select: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
select: anObject value: aBoolean
	aBoolean
		ifTrue: [ self select: anObject ]
		ifFalse: [ self deselect: anObject ].! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionComment
	^ MAStringDescription selector: #comment label: 'Comment' priority: 200.! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionTitle
	^ MAStringDescription selector: #title label: 'Title' priority: 100.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
cascade
	^ self propertyAt: #cascade ifAbsent: [ self defaultCascade ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
cascade: anArray
	self propertyAt: #cascade put: anArray.! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
column
	^ self report cache
		collect: [ :each | self valueFor: each ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
comment
	^ self propertyAt: #comment ifAbsent: [ self defaultComment ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultCascade
	^ #( yourself )! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultComment
	^ nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultDownArrow
	^ ScriptingSystem formAtKey: #DownArrow.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultFooter
	^ nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 6/21/2005 19:59'!
defaultFormat
	^ MessageSend receiver: self selector: #renderCellContent:on:.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultSorter
	^ [ :a :b | a < b ]! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultTitle
	^ self cascade first asCapitalizedPhrase.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultUpArrow
	^ ScriptingSystem formAtKey: #UpArrow.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultVisible
	^ true! !

!MAColumn methodsFor: 'exporting' stamp: 'lr 6/15/2005 21:29'!
exportContent: anObject index: aNumber on: aStream
	aStream nextPutAll: (anObject asLabel collect: [ :each |
		each isSeparator 
			ifTrue: [ Character space ]
			ifFalse: [ each ] ]).! !

!MAColumn methodsFor: 'exporting' stamp: 'lr 5/4/2005 10:21'!
exportHeadOn: aStream
	self title isNil 
		ifFalse: [ aStream nextPutAll: self title ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
footer
	^ self propertyAt: #footer ifAbsent: [ self defaultFooter ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
footer: aBlock
	self propertyAt: #footer put: aBlock.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
format
	^ self propertyAt: #format ifAbsent: [ self defaultFormat ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
format: aBlock
	self propertyAt: #format put: aBlock.! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
index
	^ self report columns indexOf: self.! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
initialize
	super initialize.
	properties := Dictionary new.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isReversed
	^ self report sortReversed.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isSortable
	^ self report sortEnabled 
		and: [ self sorter notNil ].! !

!MAColumn methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isSorted
	^ self report sortColumn = self.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isVisible
	^ self visible.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:29'!
properties
	^ properties! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:29'!
propertyAt: aSymbol
	^ self properties at: aSymbol.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:29'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^ self properties at: aSymbol ifAbsentPut: aBlock.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:29'!
propertyAt: aSymbol ifAbsent: aBlock
	^ self properties at: aSymbol ifAbsent: aBlock.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:29'!
propertyAt: aSymbol put: anObject
	^ self properties at: aSymbol put: anObject.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
refresh! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 20:00'!
renderCellContent: anObject on: html
	html render: (self valueFor: anObject).! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 19:58'!
renderCell: anObject on: html
	html tableData: [
		self format in: [ :format |
			format numArgs caseOf: {
				[ 1 ] -> [ html render: (format value: anObject) ].
				[ 2 ] -> [ format valueWithArguments: (Array with: anObject with: html) ].
			} otherwise: [ self error: 'Invalid renderer block' ] ] ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:29'!
renderFootCellOn: html
	html tableData: [ self renderFootContentOn: html ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:29'!
renderFootContentOn: html
	self footer isNil
		ifFalse: [ html render: self footer ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:29'!
renderHeadCellOn: html
	self comment isEmptyOrNil
		ifFalse: [ html attributeAt: 'title' put: self comment ].
	html tableData: [ 
		self isSortable
			ifFalse: [ self renderHeadContentOn: html ]
			ifTrue: [
				html
					anchorWithCallback: [ self report sort: self ]
					do: [ 
						self renderHeadContentOn: html.
						self renderHeadSorterOn: html ] ] ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:29'!
renderHeadContentOn: html
	html render: self title.! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:29'!
renderHeadSorterOn: html
	self isSorted ifTrue: [
		html imageWithForm: (self isReversed 
			ifTrue: [ self report sortArrowUp ]
			ifFalse: [ self report sortArrowDown ]) ].! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
report
	^ report! !

!MAColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
selector: aSymbol
	self cascade: (Array with: aSymbol).! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
setReport: aReport
	report := aReport.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
sorter
	^ self propertyAt: #sorter ifAbsent: [ self defaultSorter ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
sorter: aBlock
	self propertyAt: #sorter put: aBlock.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
sortRows: aCollection
	| result |
	result := SortedCollection new: aCollection size.
	result 
		sortBlock: [ :a :b | 
			[ (self valueFor: a) < (self valueFor: b) ]
				ifError: [ false ] ];
		addAll: aCollection.
	^ self isReversed
		ifFalse: [ result ]
		ifTrue: [ result reversed ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
title
	^ self propertyAt: #title ifAbsent: [ self defaultTitle ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
title: aString
	self propertyAt: #title put: aString.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
valueFor: aRow
	^ self cascade
		inject: aRow
		into: [ :result :each | result perform: each ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
visible
	^ self propertyAt: #visible ifAbsent: [ self defaultVisible ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:29'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MAColumn subclass: #MADescribedColumn
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:30'!
defaultCascade
	self shouldNotImplement.! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:30'!
defaultTitle
	^ self description label.! !

!MADescribedColumn methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
description
	^ description! !

!MADescribedColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 20:04'!
renderCellContent: anObject on: html
	html render: (self description toString: (self valueFor: anObject)).! !

!MADescribedColumn methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setDescription: aDescription
	description := aDescription! !

!MADescribedColumn methodsFor: 'actions' stamp: 'lr 10/25/2005 23:44'!
valueFor: aRow
	^ (aRow readUsing: self description)
		ifNil: [ self description default ].! !

MADescribedColumn subclass: #MAToggleColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAToggleColumn methodsFor: 'rendering' stamp: 'lr 6/21/2005 20:10'!
renderCellContent: anObject on: html
	(self valueFor: anObject) in: [ :value |
		html 
			anchorWithAction: [ anObject write: value not using: self description ]
			do: (self description toString: value) ].! !

!Object methodsFor: '*Magritte-Seaside-converting' stamp: 'lr 5/8/2005 20:29'!
asComponent
	^ self description asComponentOn: self.! !

!MAColorDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 5/9/2005 17:13'!
defaultComponentClasses
	^ Array with: MAColorComponent.! !

!MATimeStampDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 5/8/2005 20:34'!
defaultComponentClasses
	^ Array with: MATimeStampInputComponent.! !

!MATokenDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 8/13/2005 11:47'!
defaultComponentClasses
	^ Array with: MATextInputComponent.! !

!MADateDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 5/8/2005 20:33'!
defaultComponentClasses
	^ Array with: MADateInputComponent.! !

!MAFileModel methodsFor: '*Magritte-Seaside-rendering' stamp: 'lr 10/19/2005 23:41'!
renderImageOn: html
	html image
		altText: self asLabel;
		url: (self urlForFileOn: html).! !

!MAFileModel methodsFor: '*Magritte-Seaside-rendering' stamp: 'lr 10/19/2005 23:41'!
renderMediaOn: html
	(html tag: 'object')
		attributeAt: 'src' put: (self urlForFileOn: html);
		attributeAt: 'type' put: self mimetype;
		with: self asLabel.! !

!MAFileModel methodsFor: '*Magritte-Seaside-rendering' stamp: 'lr 10/19/2005 23:24'!
renderOn: html
	self isText
		ifTrue: [ self renderTextOn: html ]
		ifFalse: [
			self isImage
				ifTrue: [ self renderImageOn: html ]
				ifFalse: [ 
					self isAudio | self isVideo
						ifTrue: [ self renderMediaOn: html ]			
						ifFalse: [ self renderUnknownOn: html ] ] ].! !

!MAFileModel methodsFor: '*Magritte-Seaside-rendering' stamp: 'lr 10/19/2005 23:40'!
renderTextOn: html
	html preformatted with: self contents.! !

!MAFileModel methodsFor: '*Magritte-Seaside-rendering' stamp: 'lr 10/19/2005 23:41'!
renderUnknownOn: html
	html anchor
		url: (self urlForFileOn: html);
		with: self filename.! !

!MAFileModel methodsFor: '*Magritte-Seaside-rendering' stamp: 'lr 10/19/2005 23:41'!
urlForFileOn: html
	^ html context 
		urlForDocument: self contents
		mimeType: self mimetype
		fileName: self filename.! !

!MAValidationError methodsFor: '*Magritte-Seaside-rendering' stamp: 'lr 9/23/2005 12:28'!
renderOn: html
	html render: self tag label; text: ': '.
	html render: self explanation; text: '.'.! !

!MADescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 8/11/2005 09:53'!
defaultComponentClass
	^ self defaultComponentClasses notEmpty
		ifTrue: [ self defaultComponentClasses first ].	! !

!MADescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 8/10/2005 21:46'!
defaultComponentClasses
	^ Array new.! !

!MADescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 8/11/2005 09:57'!
defaultReportColumnClass
	^ self defaultReportColumnClasses notEmpty
		ifTrue: [ self defaultReportColumnClasses first ].! !

!MADescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 8/10/2005 18:03'!
defaultReportColumnClasses
	^ Array with: MADescribedColumn.! !

!MADescription class methodsFor: '*Magritte-Seaside-description' stamp: 'lr 9/26/2005 09:48'!
descriptionComponentClass
	^ (MASingleOptionDescription selector: #componentClass label: 'Component Class' priority: 1000)
		reference: MAClassDescription new;
		options: self defaultComponentClasses;
		default: self defaultComponentClass;
		yourself.! !

!MADescription class methodsFor: '*Magritte-Seaside-description' stamp: 'lr 9/26/2005 09:48'!
descriptionReportColumnClass
	^ (MASingleOptionDescription selector: #reportColumnClass label: 'Report Column Class' priority: 1010)
		reference: MAClassDescription new;
		options: self defaultReportColumnClasses;
		default: self defaultReportColumnClass;
		yourself.! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 5/8/2005 20:30'!
componentClass
	^ self propertyAt: #componentClass ifAbsent: [ self class defaultComponentClass ].! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 5/8/2005 20:30'!
componentClass: aClass
	^ self propertyAt: #componentClass put: aClass.! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 6/21/2005 20:07'!
reportColumnClass
	^ self propertyAt: #reportColumnClass ifAbsent: [ self class defaultReportColumnClass ].! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 6/21/2005 20:07'!
reportColumnClass: aClass
	^ self propertyAt: #reportColumnClass put: aClass.! !

MAVisitor subclass: #MAComponentRenderer
	instanceVariableNames: 'component html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MAComponentRenderer class methodsFor: 'instance creation' stamp: 'lr 9/23/2005 10:32'!
component: aComponent on: aRenderer
	^ self new component: aComponent on: aRenderer.! !

!MAComponentRenderer methodsFor: 'private' stamp: 'lr 10/13/2005 17:53'!
class: aString for: aDescription
	^ String streamContents: [ :stream |
		stream nextPutAll: aString.
		aDescription isReadonly
			ifTrue: [ stream space; nextPutAll: 'readonly' ].
		aDescription isRequired
			ifTrue: [ stream space; nextPutAll: 'required' ] ].! !

!MAComponentRenderer methodsFor: 'visiting' stamp: 'lr 9/23/2005 10:34'!
component: aComponent on: aRenderer
	self setComponent: aComponent; setRenderer: aRenderer.
	self visit: aComponent description.! !

!MAComponentRenderer methodsFor: 'rendering' stamp: 'lr 10/19/2005 19:52'!
renderContainer: aDescription
	self visitAll: (aDescription select: [ :each |
		each isVisible
			and: [ each componentClass notNil ] ]).! !

!MAComponentRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:16'!
renderControl: aDescription
	html render: (component childAt: aDescription).! !

!MAComponentRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:23'!
renderElement: aDescription
	self renderLabel: aDescription.
	self renderControl: aDescription.! !

!MAComponentRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:11'!
renderLabel: aDescription
	aDescription hasLabel 
		ifTrue: [ html render: aDescription label; text: ':' ].! !

!MAComponentRenderer methodsFor: 'initilization' stamp: 'lr 9/23/2005 10:33'!
setComponent: aComponent
	component := aComponent! !

!MAComponentRenderer methodsFor: 'initilization' stamp: 'lr 9/22/2005 11:58'!
setRenderer: aRenderer
	html := aRenderer! !

!MAComponentRenderer methodsFor: 'visiting-description' stamp: 'lr 9/23/2005 11:16'!
visitContainer: aDescription
	self renderContainer: aDescription.! !

!MAComponentRenderer methodsFor: 'visiting-description' stamp: 'lr 9/23/2005 11:22'!
visitElementDescription: aDescription
	self renderElement: aDescription.! !

MAComponentRenderer subclass: #MACssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:18'!
renderContainer: aDescription
	html div
		class: (self class: 'container' for: aDescription);
		with: [ super renderContainer: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:23'!
renderControl: aDescription
	html span
		class: (self class: 'control' for: aDescription);
		with: [ super renderControl: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:30'!
renderElement: aDescription
	html div
		tooltip: aDescription comment;
		class: (self class: 'element' for: aDescription);
		with: [ super renderElement: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:23'!
renderLabel: aDescription
	html span
		class: (self class: 'label' for: aDescription);
		with: [ super renderLabel: aDescription ].! !

MAComponentRenderer subclass: #MATableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:21'!
renderContainer: aDescription
	html table
		class: (self class: 'container' for: aDescription);
		with: [ super renderContainer: aDescription ].! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:22'!
renderControl: aDescription
	html tableData
		class: (self class: 'control' for: aDescription);
		with: [ super renderControl: aDescription ].! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:28'!
renderElement: aDescription
	html tableRow
		tooltip: aDescription comment;
		class: (self class: 'element' for: aDescription);
		with: [ super renderElement: aDescription ].! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 9/23/2005 11:19'!
renderLabel: aDescription
	html tableHeading
		class: (self class: 'label' for: aDescription);
		with: [ super renderLabel: aDescription ].! !

!MAElementDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 9/13/2005 22:02'!
defaultAttributes
	^ WAHtmlAttributes new.! !

!MAElementDescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 5/8/2005 20:31'!
attributes
	^ self propertyAt: #attributes ifAbsent: [ self class defaultAttributes ].! !

!MAElementDescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 5/8/2005 20:31'!
attributes: aDictionary
	^ self propertyAt: #attributes put: aDictionary.! !

WADecoration subclass: #MAComponentDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

!MAComponentDecoration methodsFor: 'private' stamp: 'lr 9/14/2005 21:22'!
rendererClass
	^ WARenderCanvas! !

MAComponentDecoration subclass: #MAContainerDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

!MAContainerDecoration methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
buttons
	self subclassResponsibility.! !

!MAContainerDecoration methodsFor: 'accessing' stamp: 'lr 9/23/2005 16:16'!
default
	^ self buttons first key.! !

!MAContainerDecoration methodsFor: 'testing' stamp: 'lr 9/22/2005 23:06'!
isMultipart
	^ self component isMultipart.! !

!MAContainerDecoration methodsFor: 'rendering' stamp: 'lr 9/23/2005 13:02'!
renderButtonsOn: html
	html div
		class: 'buttons'; 
		with: [ 
			self buttons do: [ :each |
				html submitButton
					on: each key of: self component;
					text: each value ] ].! !

!MAContainerDecoration methodsFor: 'rendering' stamp: 'lr 10/18/2005 23:56'!
renderContentOn: html
	html form
		multipart: self isMultipart;
		defaultAction: [ self component perform: self default ];
		with: [ self renderOwnerOn: html; renderButtonsOn: html ].! !

MAContainerDecoration subclass: #MAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

!MAFormDecoration class methodsFor: 'instance creation' stamp: 'lr 9/23/2005 16:16'!
buttons: aCollection
	^ self new
		addButtons: aCollection;
		yourself.! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
addButtons: aCollection
	aCollection do: [ :each |
		each isVariableBinding 
			ifFalse: [ self addButton: each ]
			ifTrue: [ self addButton: each key label: each value ] ].! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
addButton: aSelector
	self addButton: aSelector label: (self labelForSelector: aSelector).! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
addButton: aSelector label: aString
	self buttons add: aSelector -> aString.! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
buttons
	^ buttons! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
buttons: aCollection
	buttons := aCollection! !

!MAFormDecoration methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:31'!
initialize
	super initialize.
	self buttons: OrderedCollection new.! !

MAContainerDecoration subclass: #MASwitchDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

!MASwitchDecoration methodsFor: 'accessing' stamp: 'lr 10/13/2005 17:53'!
buttons
	^ self component isReadonly
		ifTrue: [ Array with: #edit -> 'Edit' ]
		ifFalse: [ Array with: #save -> 'Save' with: #cancel -> 'Cancel' ].! !

!MASwitchDecoration methodsFor: 'processing' stamp: 'lr 10/18/2005 23:45'!
handleAnswer: anObject continueWith: aBlock
	self component readonly: true.
	super handleAnswer: anObject continueWith: aBlock.! !

MAComponentDecoration subclass: #MAValidationDecoration
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 9/21/2005 18:59'!
exception
	^ exception! !

!MAValidationDecoration methodsFor: 'accessing-configuration' stamp: 'lr 9/21/2005 19:00'!
exceptionSet
	^ MAValidationError! !

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 9/23/2005 12:18'!
exception: anException
	exception := anException! !

!MAValidationDecoration methodsFor: 'testing' stamp: 'lr 9/21/2005 19:00'!
hasException
	^ self exception notNil.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 10/18/2005 23:49'!
processChildCallbacks: aStream
	[ super processChildCallbacks: aStream ]
		on: self exceptionSet
		do: [ :err | self exception: err ].! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 9/23/2005 12:11'!
renderContentOn: html
	self hasException
		ifTrue: [ self renderExceptionOn: html ].
	self renderOwnerOn: html.
	! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 10/18/2005 23:51'!
renderExceptionOn: html
	html div
		class: 'validation';
		with: self exception.
	self exception: nil.! !

!MATimeDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 5/8/2005 20:34'!
defaultComponentClasses
	^ Array with: MATimeInputComponent.! !

!MABooleanDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultComponentClasses
	^ Array with: MACheckboxComponent.! !

!MADurationDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 5/8/2005 20:33'!
defaultComponentClasses
	^ Array with: MADurationInputComponent.! !

!MAContainer class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultComponentClasses
	^ Array with: MAContainerComponent.! !

!MAContainer class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 9/23/2005 18:13'!
defaultComponentRenderer
	^ MATableRenderer! !

!MAContainer methodsFor: '*Magritte-Seaside-converting' stamp: 'lr 9/23/2005 10:59'!
asComponentOn: anObject
	^ self componentClass
		memento: (anObject mementoClass 
			model: anObject 
			description: self).! !

!MAContainer methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 9/23/2005 10:31'!
componentRenderer
	^ self propertyAt: #componentRenderer ifAbsent: [ self class defaultComponentRenderer ].! !

!MAContainer methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 9/23/2005 10:31'!
componentRenderer: aClass
	self propertyAt: #componentRenderer put: aClass.! !

!MANumberDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 10/3/2005 12:24'!
defaultComponentClasses
	^ Array with: MATextInputComponent with: MARangeComponent.! !

WAComponent subclass: #MAComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Basic'!

MAComponent subclass: #MAColorChooser
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Basic'!

!MAColorChooser commentStamp: '<historical>' prior: 0!
MAColorComponent use me to display a beautiful palette!

!MAColorChooser class methodsFor: 'instance creation' stamp: 'lr 9/21/2005 18:25'!
color: aColor
	^ self new
		color: aColor;
		yourself.! !

!MAColorChooser methodsFor: 'actions' stamp: 'lr 5/9/2005 19:39'!
cancel
	self answer: nil.! !

!MAColorChooser methodsFor: 'accessing' stamp: 'lr 5/9/2005 19:37'!
color
	^ color! !

!MAColorChooser methodsFor: 'accessing' stamp: 'lr 8/11/2005 17:00'!
color: aColor
	color := aColor! !

!MAColorChooser methodsFor: 'accessing-dynamic' stamp: 'lr 7/7/2005 17:06'!
palette
	^ Color colorPaletteForDepth: 16 extent: 200 @ 100.! !

!MAColorChooser methodsFor: 'rendering' stamp: 'lr 9/23/2005 10:03'!
renderContentOn: html
	html image
		"callback: [ :point | self answer: (self palette colorAt: point) ];"
		form: self palette.! !

!MAColorChooser methodsFor: 'actions' stamp: 'lr 5/9/2005 19:39'!
save
	self answer: self color.! !

!MAComponent methodsFor: 'private' stamp: 'lr 9/14/2005 07:27'!
rendererClass
	^ WARenderCanvas! !

MAComponent subclass: #MADescriptionComponent
	instanceVariableNames: 'memento description parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADescriptionComponent commentStamp: '<historical>' prior: 0!
I'm a seaside object which provides all the functions for my subclasses to display MADescription subclasses.!

MADescriptionComponent subclass: #MAContainerComponent
	instanceVariableNames: 'children readonly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAContainerComponent class methodsFor: 'examples' stamp: 'lr 10/18/2005 23:35'!
exampleEditor
	^ MAPersonModel new asComponent
		addValidatedForm;
		yourself.! !

!MAContainerComponent class methodsFor: 'examples' stamp: 'lr 10/18/2005 23:36'!
exampleSwitch
	^ MAPersonModel new asComponent
		addValidatedSwitch;
		yourself.! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 10/10/2005 20:33'!
addForm
	self addForm: #( save cancel ).! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 9/22/2005 11:45'!
addForm: aCollection
	self addDecoration: (MAFormDecoration buttons: aCollection).! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 9/22/2005 11:46'!
addSwitch
	self addDecoration: MASwitchDecoration new.
	self readonly: true.! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 9/22/2005 11:45'!
addValidatedForm
	self addForm; addValidation.! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 9/22/2005 11:46'!
addValidatedForm: aCollection
	self addForm: aCollection; addValidation.! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 9/22/2005 11:46'!
addValidatedSwitch
	self addSwitch; addValidation.! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 9/22/2005 11:45'!
addValidation
	self addDecoration: MAValidationDecoration new.! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 9/22/2005 11:44'!
cancel
	self reset; answer: nil.! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 9/23/2005 10:27'!
childAt: aDescription
	^ children at: aDescription ifAbsentPut: [
		aDescription componentClass
			memento: self memento
			description: aDescription
			parent: self ].! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:03'!
children
	^ children values.! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 10/18/2005 23:30'!
edit
	self readonly: false.! !

!MAContainerComponent methodsFor: 'initialization' stamp: 'lr 9/23/2005 10:18'!
initialize
	super initialize.
	children := Dictionary new.! !

!MAContainerComponent methodsFor: 'testing' stamp: 'lr 9/22/2005 23:05'!
isMultipart
	^ self children anySatisfy: [ :each | each isMultipart ].! !

!MAContainerComponent methodsFor: 'testing' stamp: 'lr 10/18/2005 22:29'!
isReadonly
	^ super isReadonly or: [ self readonly ].! !

!MAContainerComponent methodsFor: 'accessing-properties' stamp: 'lr 10/18/2005 22:29'!
readonly
	^ readonly ifNil: [ readonly := false ].! !

!MAContainerComponent methodsFor: 'accessing-properties' stamp: 'lr 10/19/2005 00:00'!
readonly: aBoolean
	readonly := aBoolean! !

!MAContainerComponent methodsFor: 'rendering' stamp: 'lr 9/23/2005 13:04'!
renderContentOn: html
	self description componentRenderer 
		component: self on: html.! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 9/23/2005 13:04'!
save
	self validate; commit; answer: self model.! !

!MADescriptionComponent class methodsFor: 'instance creation' stamp: 'lr 9/23/2005 11:00'!
memento: aMemento
	^ self memento: aMemento description: aMemento description.! !

!MADescriptionComponent class methodsFor: 'instance creation' stamp: 'lr 9/23/2005 10:20'!
memento: aMemento description: aDescription
	^ self memento: aMemento description: aDescription parent: nil.! !

!MADescriptionComponent class methodsFor: 'instance creation' stamp: 'lr 9/23/2005 11:00'!
memento: aMemento description: aDescription parent: aComponent
	^ self new
		setMemento: aMemento;
		setDescription: aDescription;
		setParent: aComponent;
		yourself.! !

!MADescriptionComponent methodsFor: 'actions' stamp: 'lr 10/3/2005 16:51'!
commit
	self memento commit.! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 9/23/2005 10:17'!
description
	^ description! !

!MADescriptionComponent methodsFor: 'accessing-dynamic' stamp: 'lr 10/3/2005 16:06'!
id
	^ self class name asLowercase , self hash asString.! !

!MADescriptionComponent methodsFor: 'testing' stamp: 'lr 9/22/2005 23:04'!
isMultipart
	^ false! !

!MADescriptionComponent methodsFor: 'testing' stamp: 'lr 10/18/2005 23:44'!
isReadonly
	^ self description isReadonly
		or: [ self isRoot not 
		and: [ self parent isReadonly ] ].! !

!MADescriptionComponent methodsFor: 'testing' stamp: 'lr 10/18/2005 23:42'!
isRoot
	^ self parent isNil.! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 9/23/2005 10:13'!
memento
	^ memento! !

!MADescriptionComponent methodsFor: 'accessing-dynamic' stamp: 'lr 9/22/2005 11:43'!
model
	^ self memento model.! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
parent
	^ parent! !

!MADescriptionComponent methodsFor: 'actions' stamp: 'lr 10/3/2005 16:51'!
reset
	self memento reset.! !

!MADescriptionComponent methodsFor: 'accessing-dynamic' stamp: 'lr 10/18/2005 23:43'!
root
	^ self isRoot 
		ifTrue: [ self ]
		ifFalse: [ self parent root ].! !

!MADescriptionComponent methodsFor: 'initialization' stamp: 'lr 9/23/2005 10:36'!
setDescription: aDescription
	description := aDescription! !

!MADescriptionComponent methodsFor: 'initialization' stamp: 'lr 9/23/2005 10:13'!
setMemento: aMemento
	memento := aMemento! !

!MADescriptionComponent methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setParent: aComponent
	parent := aComponent! !

!MADescriptionComponent methodsFor: 'actions' stamp: 'lr 10/3/2005 16:49'!
validate
	self memento validate.! !

MADescriptionComponent subclass: #MAElementComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAElementComponent commentStamp: '<historical>' prior: 0!
I provide a basic display for all subclasses of MAElementDescription (only for readonly descriptions). The object is just displayed as a string. For more complex behaviour, overried #renderViewerOn:. !

MAElementComponent subclass: #MACheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxComponent commentStamp: '<historical>' prior: 0!
I'm a seaside component used to display MABooleanDescription. If I'm writeable (readonly property of my description to false) I display a checkbox otherwise, I display a string: 'yes' if true, 'no' if false', '' if nil.!

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 10/13/2005 17:52'!
renderContentOn: html
	html label with: [
		html checkbox
			attributes: self description attributes;
			disabled: self isReadonly;
			on: #value of: self.
		html render: self description label ].! !

MAElementComponent subclass: #MAColorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAColorComponent commentStamp: '<historical>' prior: 0!
Seaside component of MAColorDescription. I display a little box with the current selected color. If you click on the box, a beautiful palette will be displayed thanks to MAColorChooser.!

!MAColorComponent methodsFor: 'actions' stamp: 'lr 10/18/2005 22:31'!
choose
	self chooser: (MAColorChooser color: self value).! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 7/7/2005 16:20'!
form
	| form |
	form := Form extent: self width @ self height depth: 32.
	form getCanvas
		drawPolygon: (Array with: 0 @ self height with: 0 @ 0 with: self width @ 0)
			color: Color white borderWidth: 0 borderColor: Color white;
		drawPolygon: (Array with: 0 @ self height with: self width @ self height with: self width @ 0)
			color: Color black borderWidth: 0 borderColor: Color white;
		fillRectangle: (0 @ 0 extent: self width @ self height)
			color: self value.
	^ form.! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 7/7/2005 15:50'!
height
	^ 15! !

!MAColorComponent methodsFor: 'rendering' stamp: 'lr 9/14/2005 20:43'!
renderEditorOn: html
	html imageButton
		callback: [ self choose ];
		attributeAt: 'width' put: self width;
		attributeAt: 'height' put: self height;
		attributeAt: 'src' put: (html context urlForDocument: self form).! !

!MAColorComponent methodsFor: 'rendering' stamp: 'lr 9/14/2005 20:38'!
renderViewerOn: html
	html image form: self form.! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 5/9/2005 18:03'!
value
	^ super value ifNil: [ self description kind transparent ].! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 7/7/2005 15:50'!
width
	^ 30! !

MAElementComponent subclass: #MADurationInputComponent
	instanceVariableNames: 'fields days hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADurationInputComponent methodsFor: 'private' stamp: 'lr 5/8/2005 20:38'!
buildDuration
	^ [ Duration days: self days hours: self hours minutes: self minutes seconds: self seconds ]
		on: Error
		do: [ :err | self memento errorValidation ].! !

!MADurationInputComponent methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
buildFields
	^ Array
		with: (self buildField: #days label: 'days' size: 3)
		with: (self buildField: #hours label: 'hours' size: 2)
		with: (self buildField: #minutes label: 'minutes' size: 2)
		with: (self buildField: #seconds label: 'seconds' size: 2).! !

!MADurationInputComponent methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
buildField: aSelector label: aString size: anInteger
	^ (MANumberDescription selector: aSelector label: self description label , '(' , aString , ')')
		attributes: (Array with: 'size' -> anInteger with: 'maxlength' -> anInteger);
		propertyAt: #shortlabel put: aString;
		asComponentOn: self.! !

!MADurationInputComponent methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
commit
	| empty |
	self fields do: [ :each | each commit ].
	empty := self fields allSatisfy: [ :each | 
		each value isNil
			or: [ each value isString ] ].
	self value: (empty
		ifTrue: [ nil ] 
		ifFalse: [ self buildDuration ]).
	super commit.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 5/8/2005 20:31'!
days
	days isNil ifTrue: [
		days := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value days ] ].
	^ days.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 5/8/2005 20:30'!
days: anInteger
	days := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MADurationInputComponent methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
fields
	fields isNil
		ifTrue: [ fields := self buildFields ].
	^ fields.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 5/8/2005 20:30'!
hours
	hours isNil ifTrue: [
		hours := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value hours ] ].
	^ hours.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 5/8/2005 20:30'!
hours: anInteger
	hours := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 5/8/2005 20:30'!
minutes
	minutes isNil ifTrue: [
		minutes := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value minutes ] ].
	^ minutes.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 5/8/2005 20:31'!
minutes: anInteger
	minutes := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MADurationInputComponent methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:31'!
renderEditorOn: html
	self fields 
		do: [ :each | 
			each renderEditorOn: html.
			html render: (each description propertyAt: #shortlabel) ]
		separatedBy: [ html space: 2 ].! !

!MADurationInputComponent methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
reset
	super reset.
	fields := days := hours := minutes := seconds := nil.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 5/8/2005 20:30'!
seconds
	seconds isNil ifTrue: [
		seconds := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value seconds ] ].
	^ seconds.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 5/8/2005 20:31'!
seconds: anInteger
	seconds := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MAElementComponent methodsFor: 'calling' stamp: 'lr 10/19/2005 21:12'!
chooser: aComponent
	self chooser: aComponent titled: 'Edit ' , self description label.! !

!MAElementComponent methodsFor: 'calling' stamp: 'lr 9/23/2005 16:27'!
chooser: aComponent titled: aString
	| result |
	result := self root call: (aComponent
		addMessage: aString;
		yourself).
	result isNil
		ifFalse: [ self value: result ].! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 9/26/2005 08:24'!
reference
	^ self description reference.! !

!MAElementComponent methodsFor: 'rendering' stamp: 'lr 10/13/2005 17:52'!
renderContentOn: html
	self isReadonly
		ifTrue: [ self renderViewerOn: html ]
		ifFalse: [ self renderEditorOn: html ].! !

!MAElementComponent methodsFor: 'rendering' stamp: 'lr 9/22/2005 22:44'!
renderEditorOn: html
	self renderViewerOn: html.! !

!MAElementComponent methodsFor: 'rendering' stamp: 'lr 9/22/2005 22:44'!
renderViewerOn: html
	html render: self string.! !

!MAElementComponent methodsFor: 'accessing-model' stamp: 'lr 9/22/2005 22:33'!
string
	^ self description toString: self value.! !

!MAElementComponent methodsFor: 'accessing-model' stamp: 'lr 9/23/2005 10:10'!
string: aString
	| value |
	value := [ self description fromString: aString ]
		ifError: [ aString ].
	self value: value.! !

!MAElementComponent methodsFor: 'accessing-model' stamp: 'lr 9/22/2005 22:30'!
value
	^ self memento readUsing: self description.! !

!MAElementComponent methodsFor: 'accessing-model' stamp: 'lr 9/22/2005 22:32'!
value: anObject
	self memento write: anObject using: self description.! !

MAElementComponent subclass: #MAFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFileUploadComponent commentStamp: '<historical>' prior: 0!
I'm the MAFileDescription seaside component. With me user can upload files to the server. I provide a button for the user to browse their computer for files.!

!MAFileUploadComponent methodsFor: 'testing' stamp: 'lr 9/22/2005 23:04'!
isMultipart
	^ true! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 8/10/2005 20:18'!
remove
	self value: nil.! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 10/19/2005 00:10'!
renderEditorOn: html
	(self value isNil or: [ self value isEmpty ])
		ifTrue: [ self renderUploadOn: html ]
		ifFalse: [ self renderRemoveOn: html ].! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 9/14/2005 21:05'!
renderRemoveOn: html
	self renderViewerOn: html.
	html submitButton on: #remove of: self.! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 10/19/2005 00:12'!
renderUploadOn: html
	html fileUpload 
		attributes: self description attributes;
		on: #upload of: self.! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 10/19/2005 23:18'!
renderViewerOn: html 
	html render: self value.! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 8/10/2005 20:25'!
upload: aFile
	self value: (aFile isNil ifFalse: [
		self description kind new
			contents: aFile contents;
			filename: aFile fileName;
			mimetype: aFile contentType;
			yourself ]).! !

MAElementComponent subclass: #MAMultipleSelectionComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAMultipleSelectionComponent commentStamp: '<historical>' prior: 0!
I provide basic functionalities for MAListCompositionComponent and MACheckboxGroupComponent.!

MAMultipleSelectionComponent subclass: #MACheckboxGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxGroupComponent commentStamp: '<historical>' prior: 0!
Use for MAMultipleSelectionComponent. I display as many checkboxes as my description has options. Another representation for the same description is MAListCompositionComponent.!

!MACheckboxGroupComponent methodsFor: 'rendering' stamp: 'lr 9/26/2005 08:30'!
renderEditorOn: html
	self description allOptions
		do: [ :each |
			html label: [
				html checkbox 
					attributes: self description attributes;
					value: (self selectedList includes: each);
					onTrue: [ self add: each ] onFalse: [ self remove: each ].
				html text: (self reference toString: each) ] ]
		separatedBy: [ html break ].! !

MAMultipleSelectionComponent subclass: #MAListCompositonComponent
	instanceVariableNames: 'availableSelected selectedSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAListCompositonComponent commentStamp: '<historical>' prior: 0!
I'm, like MACheckboxComponent, a seaside component for MAMultipleSelectionDescription. I display two lists. In the first, all available options, in the other, what the user selected. 2 buttons in between to add and remove elements to/from the selected list. If the everything property is set, I display two more buttons to allow the user to add or remove all options in one click.!

!MAListCompositonComponent methodsFor: 'actions' stamp: 'dc 8/13/2005 20:51'!
add
	self availableSelected isNil
		ifTrue: [ ^ self ].
	self add: self availableSelected.
	self selectedSelected: self availableSelected.
	self description isUnique
		ifTrue: [ self availableSelected: nil ].! !

!MAListCompositonComponent methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
availableSelected
	^ availableSelected! !

!MAListCompositonComponent methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
availableSelected: anObject
	availableSelected := anObject! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
moveDown
	self selectedSelected isNil 
		ifFalse: [ self selectedList moveDown: self selectedSelected ].! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
moveUp
	self selectedSelected isNil 
		ifFalse: [ self selectedList moveUp: self selectedSelected ].! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'dc 8/13/2005 20:51'!
remove
	self selectedSelected isNil
		ifTrue: [ ^ self ].
	self remove: self selectedSelected.
	self availableSelected: self selectedSelected.
	self selectedSelected: nil.! !

!MAListCompositonComponent methodsFor: 'rendering-parts' stamp: 'lr 9/30/2005 20:49'!
renderEditorAvailableOn: html
	html select
		attributes: self description attributes;
		size: 6; style: 'width: 150px';
		list: self availableList;
		selected: self availableSelected;
		callback: [ :value | self availableSelected: value ];
		labels: [ :value | self reference toString: value ].! !

!MAListCompositonComponent methodsFor: 'rendering-buttons' stamp: 'lr 9/26/2005 08:39'!
renderEditorButtonAddOn: html
	html submitButton
		callback: [ self add ];
		text: '>>'.
	html break.
	html submitButton
		callback: [ self remove ];
		text: '<<'.! !

!MAListCompositonComponent methodsFor: 'rendering-buttons' stamp: 'lr 9/26/2005 08:38'!
renderEditorButtonOrderOn: html
	html submitButton
		callback: [ self moveUp ];
		text: 'up'.
	html break.
	html submitButton
		callback: [ self moveDown ];
		text: 'down'.! !

!MAListCompositonComponent methodsFor: 'rendering' stamp: 'lr 9/26/2005 08:40'!
renderEditorOn: html
	html table with: [
		html tableRow with: [
			html tableData 
				with: [ self renderEditorAvailableOn: html ].
			html tableData
				align: 'center';
				with: [ self renderEditorButtonAddOn: html ].
			html tableData
				with: [ self renderEditorSelectedOn: html ].
			html tableData
				align: 'center';
				with: [ self renderEditorButtonOrderOn: html ] ] ].! !

!MAListCompositonComponent methodsFor: 'rendering-parts' stamp: 'lr 9/30/2005 20:49'!
renderEditorSelectedOn: html
	html select
		attributes: self description attributes;
		size: 6; style: 'width: 150px';
		list: self selectedList;
		selected: self selectedSelected;
		callback: [ :value | self selectedSelected: value ];
		labels: [ :value | self reference toString: value ].! !

!MAListCompositonComponent methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
selectedSelected
	^ selectedSelected! !

!MAListCompositonComponent methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
selectedSelected: anObject
	selectedSelected := anObject! !

!MAMultipleSelectionComponent methodsFor: 'actions' stamp: 'lr 9/26/2005 08:32'!
add: anObject
	self selectedList add: anObject.! !

!MAMultipleSelectionComponent methodsFor: 'accessing-list' stamp: 'lr 5/8/2005 20:31'!
availableList
	^ self description isUnique
		ifFalse: [ self description allOptions ]
		ifTrue: [ 
			self description allOptions reject: [ :each |
				self selectedList includes: each ] ].! !

!MAMultipleSelectionComponent methodsFor: 'actions' stamp: 'lr 9/26/2005 08:32'!
remove: anObject
	self selectedList remove: anObject ifAbsent: nil.! !

!MAMultipleSelectionComponent methodsFor: 'rendering' stamp: 'lr 9/26/2005 08:24'!
renderViewerOn: html
	html unorderedList
		list: self selectedList;
		labels: [ :each | self reference toString: each ].! !

!MAMultipleSelectionComponent methodsFor: 'accessing-list' stamp: 'lr 9/30/2005 20:46'!
selectedList
	^ self value ifNil: [ Array new ].! !

!MAMultipleSelectionComponent methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
value
	(self description isSatisfiedBy: super value)
		ifFalse: [ self value: OrderedCollection new ].
	^ super value.! !

MAElementComponent subclass: #MARadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARadioGroupComponent commentStamp: '<historical>' prior: 0!
I display a set of radio buttons to render MASingleSelectionDescription.!

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'lr 9/26/2005 08:25'!
renderEditorOn: html
	html radioGroup: [ :group |
		self description allOptions
			do: [ :each |
				html label: [
					html radioButton
						attributes: self description attributes;
						group: group;
						selected: self value = each;
						callback: [ self value: each ].
					html text: (self reference toString: each) ] ]
			separatedBy: [ html break ] ].! !

MAElementComponent subclass: #MARangeComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARangeComponent methodsFor: 'accessing-dynamic' stamp: 'lr 10/19/2005 20:12'!
max
	^ self description max ifNil: [ 100 ].! !

!MARangeComponent methodsFor: 'accessing-dynamic' stamp: 'lr 10/19/2005 20:12'!
min
	^ self description min ifNil: [ -100 ].! !

!MARangeComponent methodsFor: 'accessing-dynamic' stamp: 'lr 10/19/2005 20:12'!
range
	^ self max - self min.! !

!MARangeComponent methodsFor: 'rendering' stamp: 'lr 10/18/2005 22:19'!
renderEditorOn: html
	html textInput
		attributes: self description attributes;
		id: self id; beRangeInput;
		attributeAt: 'oninput' put: self updateScript;
		attributeAt: 'min' put: 0;
		attributeAt: 'max' put: 100;
		on: #string of: self.
	html span id: self id , 'v'.
	html script: self updateScript.! !

!MARangeComponent methodsFor: 'private' stamp: 'lr 10/19/2005 20:12'!
updateScript
	^ String streamContents: [ :stream |
		stream 
			nextPutAll: 'document.getElementById('; print: self id , 'v';
			nextPutAll: ').innerHTML = document.getElementById('; print: self id;
			nextPutAll: ').value * ('; print: self range; 
			nextPutAll: ') / 100 + ('; print: self min; 
			nextPutAll: ');' ].! !

!MARangeComponent methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:12'!
value
	^ (super value ifNil: [ 0 ]) - self min * 100 / self range.! !

!MARangeComponent methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:12'!
value: aNumber
	super value: (aNumber ifNotNil: [ aNumber * self range / 100 + self min ]).! !

MAElementComponent subclass: #MARelationComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MARelationComponent subclass: #MAOneToOneComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAOneToOneComponent methodsFor: 'actions' stamp: 'lr 10/20/2005 00:23'!
edit
	self edit: self value.! !

!MAOneToOneComponent methodsFor: 'private' stamp: 'lr 10/19/2005 20:45'!
editorFor: anObject
	^ (self reference asComponentOn: anObject)
		addValidatedForm;
		yourself.! !

!MAOneToOneComponent methodsFor: 'actions' stamp: 'lr 10/20/2005 00:23'!
edit: anObject
	self chooser: (self editorFor: anObject).! !

!MAOneToOneComponent methodsFor: 'actions' stamp: 'lr 10/19/2005 23:50'!
remove
	self value: nil.! !

!MAOneToOneComponent methodsFor: 'rendering' stamp: 'lr 10/19/2005 20:40'!
renderContentOn: html
	self renderViewerOn: html.
	self isReadonly 
		ifFalse: [ self renderEditorOn: html ].! !

!MAOneToOneComponent methodsFor: 'rendering' stamp: 'lr 10/20/2005 00:34'!
renderEditorExistingOn: html
	self reference isReadonly
		ifFalse: [ html submitButton on: #edit of: self ].
	html submitButton on: #remove of: self.! !

!MAOneToOneComponent methodsFor: 'rendering' stamp: 'lr 10/20/2005 00:30'!
renderEditorInexistingOn: html
	| prototypes value |
	prototypes := self description allPrototypes.
	prototypes isEmpty 
		ifTrue: [ value := Array with: self description default ]
		ifFalse: [
			value := Array with: prototypes first.
			prototypes size > 1 ifTrue: [
				html select
					list: prototypes;
					selected: value first;
					callback: [ :each | value at: 1 put: each ];
					labels: [ :each | self reference toString: each ] ] ].
	html submitButton
		callback: [
			value first isNil 
				ifFalse: [ self edit: value first copy ] ];
		text: 'Create'.! !

!MAOneToOneComponent methodsFor: 'rendering' stamp: 'lr 10/20/2005 00:30'!
renderEditorOn: html
	self value isNil
		ifTrue: [ self renderEditorInexistingOn: html ]
		ifFalse: [ self renderEditorExistingOn: html ].! !

MAElementComponent subclass: #MASelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASelectListComponent commentStamp: '<historical>' prior: 0!
I display a simple list to allow the user to choose one element from the list. I am one of the two seaside components to render MASingleSelectionDescription.!

!MASelectListComponent methodsFor: 'rendering' stamp: 'lr 9/26/2005 08:25'!
renderEditorOn: html
	html select
		attributes: self description attributes;
		list: self description allOptions;
		selected: self value;
		callback: [ :value | self value: value ];
		labels: [ :value | self reference toString: value ].! !

MAElementComponent subclass: #MATableComponent
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATableComponent methodsFor: 'private' stamp: 'lr 9/27/2005 07:29'!
buildCells
	| row column |
	^ self value collectWithIndex: [ :each :index |
		row := self description rowOfIndex: index.
		column := self description columnOfIndex: index.
		self description reference copy
			accessor: MANullAccessor new;
			propertyAt: #tableIndex put: index;
			label: (String streamContents: [ :stream |
				stream nextPutAll: (self description label); nextPutAll: ' ('.
				stream nextPutAll: (self description columnLabels at: column); nextPutAll: ' / '.
				stream nextPutAll: (self description rowLabels at: row); nextPutAll: ')' ]);
			comment: (String streamContents: [ :stream |
				stream nextPutAll: (self description columnLabels at: column); nextPutAll: ' / '.
				stream nextPutAll: (self description rowLabels at: row) ]);
			asComponentOn: self ].! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
cellAt: aRowIndex at: aColIndex
	^ self cells at: (self description indexAt: aRowIndex at: aColIndex).! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
cells
	cells isNil
		ifTrue: [ cells := self buildCells ].
	^ cells.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
commit
	self cells do: [ :each | each commit ].
	super commit.! !

!MATableComponent methodsFor: 'accessing-configuration' stamp: 'lr 5/8/2005 20:32'!
defaultValue
	^ Array new: self description cellCount.! !

!MATableComponent methodsFor: 'private' stamp: 'lr 5/8/2005 20:32'!
readUsing: aDescription
	^ self value at: (aDescription propertyAt: #tableIndex).! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 10/19/2005 07:39'!
renderTableCells: aBlock on: html
	html table: [
		html tableRow: [
			html tableHeading: nil.
			self description columnLabels do: [ :each |
				html tableHeading: each ] ].
		self description rowLabels withIndexDo: [ :row :rindex |
			html tableRow: [
				html tableHeading: row.
				self description columnLabels withIndexDo: [ :col :cindex |
					(self value uncheckedAt: rindex at: cindex) in: [ :component |
						html attributeAt: 'title' put: component description comment.
						html tableData: [ aBlock value: component ] ] ] ] ] ].! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 10/19/2005 07:38'!
renderViewerOn: html
	self renderTableCells: [ :each | html render: each ] on: html.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
reset
	super reset.
	self cells do: [ :each | each reset ].! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
validate
	self cells do: [ :each | each validate ].
	super validate.! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
value
	(self description isSatisfiedBy: super value)
		ifFalse: [ self value: self defaultValue ].
	^ super value.! !

!MATableComponent methodsFor: 'private' stamp: 'lr 9/21/2005 07:33'!
write: anObject using: aDescription
	self value at: (aDescription propertyAt: #tableIndex) put: anObject.! !

MAElementComponent subclass: #MATextAreaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextAreaComponent commentStamp: '<historical>' prior: 0!
I display an html text area for the magritte MATextAreaDescription.!

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 9/22/2005 22:46'!
renderEditorOn: html 
	html textArea
		attributes: self description attributes;
		on: #string of: self.! !

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 9/22/2005 22:55'!
renderViewerOn: html
	(self string findTokens: Character cr)
		do: [ :each | html render: each ]
		separatedBy: [ html break ].! !

MAElementComponent subclass: #MATextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextInputComponent commentStamp: '<historical>' prior: 0!
I'm a simple input box for MAStringDescription.!

MATextInputComponent subclass: #MADateInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateInputComponent methodsFor: 'actions' stamp: 'lr 10/18/2005 23:59'!
choose
	| calendar |
	calendar := WAMiniCalendar new.
	calendar
		date: ((self value notNil 
			and: [ self description isSatisfiedBy: self value ])
				ifFalse: [ Date current ]
				ifTrue: [ self value ]);
		selectBlock: [ :value | calendar answer: value ];
		canSelectBlock: [ :value | self description isSatisfiedBy: value ];
		yourself.
	self chooser: calendar.! !

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 9/22/2005 22:48'!
renderEditorOn: html
	super renderEditorOn: html.
	html submitButton on: #choose of: self.! !

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 10/3/2005 17:00'!
renderEditorOn: html
	html textInput
		attributes: self description attributes;
		on: #string of: self.! !

MATextInputComponent subclass: #MATimeInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeInputComponent methodsFor: 'actions' stamp: 'lr 5/8/2005 20:33'!
current
	self value: Time current.! !

!MATimeInputComponent methodsFor: 'rendering' stamp: 'lr 9/22/2005 22:48'!
renderEditorOn: html
	super renderEditorOn: html.
	html submitButton on: #current of: self.! !

MATextInputComponent subclass: #MATimeStampInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeStampInputComponent methodsFor: 'actions' stamp: 'lr 5/8/2005 20:33'!
current
	self value: TimeStamp current.! !

!MATimeStampInputComponent methodsFor: 'rendering' stamp: 'lr 9/22/2005 22:48'!
renderEditorOn: html
	super renderEditorOn: html.
	html submitButton on: #current of: self.! !

MAElementComponent subclass: #MATextPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextPasswordComponent commentStamp: '<historical>' prior: 0!
Password seaside component, I display stars '*' instead of the text typed by the user. My description is MAPasswordDescription.!

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 9/23/2005 17:33'!
renderEditorOn: html
	html passwordInput
		attributes: self description attributes;
		on: #string of: self.! !

!MATextPasswordComponent methodsFor: 'accessing' stamp: 'lr 9/22/2005 22:51'!
string
	^ String new: super string size withAll: $*.   ! !

!MATextPasswordComponent methodsFor: 'accessing' stamp: 'lr 9/22/2005 22:52'!
string: aString
	self string = aString
		ifFalse: [ super string: aString ].! !

MADescriptionComponent subclass: #MAReportComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAReportComponent methodsFor: 'rendering' stamp: 'lr 8/11/2005 17:04'!
renderContentOn: html
	html table: [
		self renderTableCaptionOn: html.
		self renderTableSummaryOn: html.
		self renderTableHeadOn: html.
		self renderTableFootOn: html.
		self renderTableBodyOn: html ].! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 6/10/2005 17:48'!
renderTableBodyOn: html
	html tag: 'tbody' do: [
		self description showBody ifTrue: [ 
			self value isEmptyOrNil
				ifTrue: [ self renderTableEmptyOn: html ]
				ifFalse: [ self renderTableContentOn: html ] ] ].! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 6/10/2005 17:43'!
renderTableCaptionOn: html
	self description caption ifNotNilDo: [ :value |
		html 
			tag: 'caption' 
			do: self description caption ].! !

!MAReportComponent methodsFor: 'rendering-content' stamp: 'lr 6/10/2005 17:44'!
renderTableContentOn: html! !

!MAReportComponent methodsFor: 'rendering-content' stamp: 'lr 6/10/2005 17:48'!
renderTableEmptyOn: html! !

!MAReportComponent methodsFor: 'rendering-content' stamp: 'lr 6/10/2005 17:44'!
renderTableFooterOn: html! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 6/10/2005 17:43'!
renderTableFootOn: html
	html tag: 'tfoot' do: [
		self description showFooter
			ifTrue: [ self renderTableFooterOn: html ] ].! !

!MAReportComponent methodsFor: 'rendering-content' stamp: 'lr 6/10/2005 17:46'!
renderTableHeaderOn: html
	html tableRow: [
		self description do: [ :each |
			each isVisible ifTrue: [
				html tableData: each label ] ] ].! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 6/10/2005 17:41'!
renderTableHeadOn: html
	html tag: 'thead' do: [
		self description showHeader
			ifTrue: [ self renderTableHeaderOn: html ] ].! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 6/10/2005 17:43'!
renderTableSummaryOn: html
	self description summary ifNotNilDo: [ :value |
		html 
			tag: 'summary'
			do: self description summary ].! !

WAComponent subclass: #MAExampleEditor
	instanceVariableNames: 'description report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

MAExampleEditor subclass: #MADescriptionEditor
	instanceVariableNames: 'example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MADescriptionEditor class methodsFor: 'examples' stamp: 'lr 8/11/2005 17:15'!
example
	^ self new.! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 5/8/2005 20:30'!
addDescription: aDescription
	| element |
	element := self call: (self 
		buildEditorFor: aDescription 
		titled: 'Add ' , aDescription description label).
	element isNil ifTrue: [ ^ self ].
	self description add: element.
	self report refresh.! !

!MADescriptionEditor methodsFor: 'private' stamp: 'lr 9/27/2005 07:30'!
buildReport
	^ (MAReport rows: self description description: MAElementDescription description)
		addColumn: (MAColumn new
			cascade: #( description label );
			title: 'Kind';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'edit';
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #removeDescription: text: 'remove';
			yourself);
		yourself.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 8/11/2005 17:20'!
defaultDescription
	^ MAContainer new.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 9/13/2005 21:38'!
defaultDescriptionClasses
	^ OrderedCollection new
		add: MAStringDescription;
		add: MATextDescription;
		add: MASymbolDescription;
		add: MAPasswordDescription;
		add: nil;
		add: MABooleanDescription;
		add: MASingleOptionDescription;
		add: MAMultipleOptionDescription;
		add: nil;
		add: MANumberDescription;
		add: MADurationDescription;
		add: MADateDescription;
		add: MATimeDescription;
		add: MATimeStampDescription;
		add: nil;
		add: MAColorDescription;
		add: MATokenDescription;
		add: nil;
		add: MAFileDescription;
		"add: MATableDescription;"
		yourself.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 8/11/2005 16:52'!
defaultExampleInstance
	^ MAScaffolder description: self value description.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 9/27/2005 07:30'!
defaultReportInstance
	^ (MAReport rows: self value description: MAElementDescription description)
		addColumn: (MAColumn new
			cascade: #( description label );
			title: 'Kind';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'edit';
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #removeDescription: text: 'remove';
			yourself);
		yourself.! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 5/8/2005 20:30'!
editDescription: aDescription
	self call: (self 
		buildEditorFor: aDescription 
		titled: 'Edit ' , aDescription description label).
	self report refresh.! !

!MADescriptionEditor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
example
	example isNil
		ifTrue: [ example := self defaultExampleInstance ].
	^ example.! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 8/11/2005 16:54'!
preview
	self call: (self example asComponent
		addValidatedForm;
		yourself).! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 5/8/2005 20:30'!
removeDescription: aDescription
	self description remove: aDescription.
	self report refresh.! !

!MADescriptionEditor methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:30'!
renderButtonsOn: html
	| selected |
	selected := ValueHolder new.
	html
		selectFromList: self defaultDescriptionClasses 
		selected: self defaultDescriptionClasses first
		callback: [ :class | selected contents: class ]
		labels: [ :class | 
			class isNil
				ifTrue: [ '--' ]
				ifFalse: [ class description label ] ].
	html
		submitButtonWithAction: [
			selected contents ifNotNilDo: [ :class | 
				self addDescription: class new ] ]
		text: 'Add'.
	super renderButtonsOn: html.! !

!MAExampleEditor class methodsFor: 'as yet unclassified' stamp: 'lr 5/8/2005 20:33'!
description: aDescription
	^ self new
		description: aDescription;
		yourself.! !

!MAExampleEditor methodsFor: 'private' stamp: 'lr 9/13/2005 21:54'!
buildEditorFor: anObject titled: aString
	^ anObject asComponent
		addValidatedForm;
		addMessage: aString;
		yourself.! !

!MAExampleEditor methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
buildReport
	self subclassResponsibility.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
cancel
	self answer: nil.! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
children
	^ Array with: self report.! !

!MAExampleEditor methodsFor: 'accessing-configuration' stamp: 'lr 8/11/2005 17:20'!
defaultDescription
	self subclassResponsibility.! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 8/11/2005 17:20'!
description
	^ description ifNil: [ description := self defaultDescription ].! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
description: aDescription
	description := aDescription! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 9/23/2005 12:29'!
edit
	self call: (self 
		buildEditorFor: description
		titled: 'Edit Container').! !

!MAExampleEditor methodsFor: 'actions-items' stamp: 'lr 5/8/2005 20:31'!
moveDown: aDescription
	self description moveDown: aDescription.
	self report refresh.! !

!MAExampleEditor methodsFor: 'actions-items' stamp: 'lr 5/8/2005 20:31'!
moveUp: aDescription
	self description moveUp: aDescription.
	self report refresh.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
preview
	self subclassResponsibility.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:31'!
renderButtonsOn: html
	html submitButtonOn: #edit of: self.
	html submitButtonOn: #preview of: self.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:31'!
renderChildrenOn: html
	html render: self children.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:31'!
renderContentOn: html
	self renderChildrenOn: html.
	html form: [
		self renderButtonsOn: html ].! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
report
	^ report ifNil: [ report := self buildReport ].! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
save
	self answer: self description.! !

MAExampleEditor subclass: #MAReportEditor
	instanceVariableNames: 'columns visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MAReportEditor class methodsFor: 'examples' stamp: 'lr 10/19/2005 00:09'!
xxxexample
	^ self new.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
addColumn: aColumn
	self report addColumn: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'private' stamp: 'lr 5/8/2005 20:32'!
buildColumns
	^ (MAReport rows: self report columns)
		addColumn: self visible;
		addColumnDescription: MAColumn descriptionTitle;
		addColumnDescription: MAColumn descriptionComment;
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #remove: text: 'remove';
			yourself);
		yourself.! !

!MAReportEditor methodsFor: 'private' stamp: 'lr 5/8/2005 20:32'!
buildVisible
	^ MACheckboxColumn new
		title: 'V';
		comment: 'Visibility';
		selection: (self report columns 
			select: [ :each | each isVisible ])
			asSet;
		yourself.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
children
	^ Array with: self columns.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
columns
	columns isNil
		ifTrue: [ columns := self buildColumns ].
	^ columns.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
preview	
	self report
		decorateWith: (WAWindowDecoration new
			title: self report tableCaption;
			yourself)
		during: [ self call: self report ].! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
refresh
	self columns rows: self report columns.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
remove: aColumn
	self report remove: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:32'!
renderAddOn: html
	| selected |
	selected := ValueHolder new.
	"html
		selectFromList: self columns selected: nil
		callback: [ :value | selected contents: value ]
		labels: [ :value | value title ]."
	html
		submitButtonWithAction: [
			selected contents ifNotNilDo: [ :value | 
				self addColumn: value copy ] ]
		text: 'add'.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
report
	^ report! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
save
	 self answer: self report.! !

!MAReportEditor methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setReport: aReport
	report := aReport copy.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
visible
	visible isNil
		ifTrue: [ visible := self buildVisible ].
	^ visible.! !

WAComponent subclass: #MAReport
	instanceVariableNames: 'rows cache columns properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
description2000
	^ MABooleanDescription selector: #showHeader label: 'Show Header' priority: 2000.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
description2100
	^ MABooleanDescription selector: #showBody label: 'Show Body' priority: 2100.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
description2200
	^ MAStringDescription selector: #tableEmpty label: 'Empty' priority: 2200.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
description2300
	^ MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 2300.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
description2400
	^ MABooleanDescription selector: #showCaption label: 'Show Caption' priority: 2300.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
description2500
	^ MAStringDescription selector: #tableCaption label: 'Caption' priority: 2500.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
description2600
	^ MABooleanDescription selector: #showSummary label: 'Show Summary' priority: 2600.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
description2700
	^ MAStringDescription selector: #tableSummary label: 'Summary' priority: 2700.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 5/8/2005 20:33'!
description4000
	^ MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 4000.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 5/8/2005 20:33'!
description4100
	^ MANumberDescription selector: #batchSize label: 'Size' priority: 4100.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 5/8/2005 20:33'!
description4200
	^ MABooleanDescription selector: #showBatchFirstLast label: 'Show First/Last' priority: 4200.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 5/8/2005 20:33'!
description4300
	^ MABooleanDescription selector: #showBatchPreviousNext label: 'Show Previous/Next' priority: 4300.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 5/8/2005 20:33'!
description4400
	^ MABooleanDescription selector: #showBatchPages label: 'Show Pages' priority: 4400.! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
rows: aCollection
	^ self new
		rows: aCollection;
		yourself.! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
rows: aCollection description: aDescription
	| report |
	report := self rows: aCollection.
	aDescription asContainer do: [ :each |
		report addColumnDescription: each ].
	^ report.! !

!MAReport class methodsFor: 'examples' stamp: 'lr 10/19/2005 00:08'!
xxxexample
	^ (self rows: (0 to: 255))
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the decimal number';
			title: 'Dec');
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the binary number';
			title: 'Bin';
			format: [ :value | (value printStringBase: 2) allButFirst: 2 ];
			yourself);
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the octal number';
			title: 'Oct';
			format: [ :value | (value printStringBase: 8) allButFirst: 2 ];
			yourself);
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the hexadecimal number';
			title: 'Hex';
			format: [ :value | (value printStringBase: 16) allButFirst: 3 ];
			yourself);
		addColumn: (MAColumn new
			selector: #sin;
			comment: 'the sinus';
			title: 'Sinus');
		addColumn: (MAColumn new
			selector: #cos;
			comment: 'the cosinus';
			title: 'Cosinus');
		addColumn: (MAColumn new
			selector: #ln;
			comment: 'the natural logarithm';
			title: 'Logarithm');
		addColumn: (MAColumn new
			selector: #exp;
			comment: 'the exponential';
			title: 'Exponential');
		yourself.! !

!MAReport methodsFor: 'columns' stamp: 'lr 5/8/2005 20:32'!
addColumnCascade: anArray
	^ (self addColumn: MAColumn new)
		cascade: anArray;
		yourself.! !

!MAReport methodsFor: 'columns' stamp: 'lr 6/21/2005 20:08'!
addColumnDescription: aDescription
	^ self addColumn: (aDescription reportColumnClass new
		setDescription: aDescription;
		yourself).! !

!MAReport methodsFor: 'columns' stamp: 'lr 5/8/2005 20:32'!
addColumnSelector: aSelector
	^ (self addColumn: MAColumn new)
		selector: aSelector;
		yourself.! !

!MAReport methodsFor: 'columns' stamp: 'lr 5/8/2005 20:32'!
addColumn: aColumn
	columns := columns copyWith: aColumn.
	^ aColumn setReport: self; yourself.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
backtrackedAt: aSymbol
	^ (self propertyAt: aSymbol)
		contents.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
backtrackedAt: aSymbol ifAbsentPut: aBlock
	^ self 
		backtrackedAt: aSymbol 
		ifAbsent: [ self backtrackedAt: aSymbol put: aBlock value ].! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
backtrackedAt: aSymbol ifAbsent: aBlock
	^ (self propertyAt: aSymbol ifAbsent: [ ^ aBlock value ])
		contents.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
backtrackedAt: aSymbol put: anObject
	(self propertyAt: aSymbol ifAbsentPut: [ WAStateHolder new ])
		contents: anObject.
	^ anObject.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 5/8/2005 20:32'!
batchEndIndex
	^ self batchPage * self batchSize min: self cache size.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 5/8/2005 20:32'!
batchMaxPages
	^ (self cache size / self batchSize) 
		ceiling.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
batchPage
	^ self backtrackedAt: #batchPage ifAbsentPut: [ self defaultBatchPage ].! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 5/8/2005 20:32'!
batchPageRange
	^ self batchPageRangeStart to: self batchPageRangeEnd.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 5/8/2005 20:32'!
batchPageRangeEnd
	^ self batchMaxPages min: self batchPage + 9.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 5/8/2005 20:32'!
batchPageRangeStart
	^ self defaultBatchPage max: self batchPage - 9.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
batchPage: anInteger
	self backtrackedAt: #batchPage put: anInteger.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
batchSize
	^ self propertyAt: #batchSize ifAbsentPut: [ self defaultBatchSize ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
batchSize: anInteger
	self propertyAt: #batchSize put: anInteger.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 5/8/2005 20:32'!
batchStartIndex
	^ (self batchPage - 1) * self batchSize + 1.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
cache
	"Return the cached rows of the receiver, these rows are filtered and sorted."

	cache isNil ifTrue: [ 
		self cache: (self 
			sortRows: (self 
				filterRows: self 
					rows)) ].
	^ cache.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
cache: aCollection
	cache := aCollection! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 5/8/2005 20:32'!
columns
	^ columns! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultBatchPage
	^ 1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultBatchSize
	^ 10! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultRowFilter
	^ nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultRowPeriod
	^ 1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultRowStyles
	^ Array with: 'odd' with: 'even'.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultShowBatch
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultShowBatchFirstLast
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultShowBatchPages
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultShowBatchPreviousNext
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultShowBody
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultShowCaption
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultShowFooter
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultShowHeader
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultShowSummary
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultSortArrowDown
	^ ScriptingSystem formAtKey: #DownArrow.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultSortArrowUp
	^ ScriptingSystem formAtKey: #UpArrow.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultSortColumn
	^ nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultSortEnabled
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultSortReversed
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultTableCaption
	^ nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultTableEmpty
	^ 'The report is empty.'! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:32'!
defaultTableSummary
	^ nil! !

!MAReport methodsFor: 'exporting' stamp: 'lr 5/4/2005 10:20'!
export
	^ String streamContents: [ :stream |
		self exportOn: stream ].! !

!MAReport methodsFor: 'exporting' stamp: 'lr 5/4/2005 10:34'!
exportBodyOn: aStream
	self cache withIndexDo: [ :row :index |
		self columns
			do: [ :column |
				column
					exportContent: (column valueFor: row) 
					index: index on: aStream ]
			separatedBy: [ aStream tab ].
		aStream cr ].! !

!MAReport methodsFor: 'exporting' stamp: 'lr 5/4/2005 10:34'!
exportHeaderOn: aStream
	self columns
		do: [ :each | each exportHeadOn: aStream ]
		separatedBy: [ aStream tab ].
	aStream cr.! !

!MAReport methodsFor: 'exporting' stamp: 'lr 5/4/2005 10:20'!
exportOn: aStream
	self showHeader
		ifTrue: [ self exportHeaderOn: aStream ].
	self showBody
		ifTrue: [ self exportBodyOn: aStream ].! !

!MAReport methodsFor: 'private' stamp: 'lr 5/8/2005 20:32'!
filterRows: aCollection
	^ self hasRowFilter
		ifFalse: [ aCollection ]
		ifTrue: [ aCollection select: self rowFilter ].! !

!MAReport methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
hasRowFilter
	^ self rowFilter notNil.! !

!MAReport methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
initialize
	super initialize.
	rows := columns := Array new.
	properties := Dictionary new.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 5/8/2005 20:32'!
isOnFirstPage
	^ self batchPage = 1.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 5/8/2005 20:32'!
isOnLastPage
	^ self batchPage = self batchMaxPages.! !

!MAReport methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
isSorted
	^ self sortColumn notNil.! !

!MAReport methodsFor: 'columns' stamp: 'lr 5/8/2005 20:32'!
moveDown: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^ self ].
	self columns swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!MAReport methodsFor: 'columns' stamp: 'lr 5/8/2005 20:32'!
moveUp: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^ self ].
	self columns swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

!MAReport methodsFor: 'README' stamp: 'lr 5/8/2005 20:32'!
NOW
	" do not use ... this is unfinished, buggy and not working "! !

!MAReport methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
nextPage
	self isOnLastPage 
		ifFalse: [ self batchPage: self batchPage + 1 ].! !

!MAReport methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
previousPage
	self isOnFirstPage 
		ifFalse: [ self batchPage: self batchPage - 1 ].! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
properties
	^ properties! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
propertyAt: aSymbol
	^ self properties at: aSymbol! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^ self properties at: aSymbol ifAbsentPut: aBlock.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
propertyAt: aSymbol ifAbsent: aBlock
	^ self properties at: aSymbol ifAbsent: aBlock.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
propertyAt: aSymbol put: anObject
	^ self properties at: aSymbol put: anObject.! !

!MAReport methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
refresh
	self cache: nil; batchPage: self defaultBatchPage.
	self columns do: [ :each | each refresh ].! !

!MAReport methodsFor: 'columns' stamp: 'lr 5/8/2005 20:32'!
remove: aColumn
	columns := columns copyWithout: aColumn.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 5/8/2005 20:32'!
renderBatchFirstOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self batchPage: self defaultBatchPage ] text: '|<' ]
		ifTrue: [ html text: '|<' ].
	html space.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 5/8/2005 20:32'!
renderBatchItemsOn: html
	self batchPageRangeStart > self defaultBatchPage
		ifTrue: [ html text: '...'; space ].
	self batchPageRange do: [ :index |
		self batchPage = index
			ifFalse: [ html anchorWithAction: [ self batchPage: index ] text: index ]
			ifTrue: [ html spanClass: 'current' with: index ].
		html space ].
	self batchPageRangeEnd < self batchMaxPages 
		ifTrue: [ html text: '...'; space ].! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 5/8/2005 20:32'!
renderBatchLastOn: html
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self batchPage: self batchMaxPages ] text: '>|' ]
		ifTrue: [ html text: '>|' ].! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 5/8/2005 20:32'!
renderBatchNextOn: html
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ].
	html space.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 5/8/2005 20:32'!
renderBatchPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!MAReport methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:32'!
renderContentOn: html
	html cssClass: 'report'; table: [ self renderTableOn: html ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 5/8/2005 20:32'!
renderTableBatchOn: html
	self batchSize < self cache size ifTrue: [
		html tableRow: [
			html cssClass: 'batch'; attributeAt: 'colspan' put: self columns size.
			html tableData: [
				self showBatchFirstLast
					ifTrue: [ self renderBatchFirstOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchPreviousOn: html ].
				self showBatchPages
					ifTrue: [ self renderBatchItemsOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchNextOn: html ].
				self showBatchFirstLast
					ifTrue: [ self renderBatchLastOn: html ] ] ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 6/21/2005 19:58'!
renderTableBodyOn: html
	self visible isEmpty 
		ifTrue: [
			html cssClass: 'empty'.
			html tableRow: [
				html attributeAt: #colspan put: self columns size.
				html tableData: [
					html render: self tableEmpty ] ] ]
		ifFalse: [
			self visible withIndexDo: [ :row :index |
				html cssClass: (self rowStyleForNumber: index).
				html tableRow: [
					self columns do: [ :col |
						col renderCell: row on: html ] ] ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 5/8/2005 20:32'!
renderTableCaptionOn: html
	html tag: 'caption' do: self tableCaption.! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 5/8/2005 20:32'!
renderTableFootOn: html
	html tableRow: [
		self columns do: [ :each |
			each renderFootCellOn: html ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 5/8/2005 20:32'!
renderTableHeadOn: html
	html tableRow: [
		self columns do: [ :each |
			each renderHeadCellOn: html ] ].! !

!MAReport methodsFor: 'rendering' stamp: 'lr 5/8/2005 20:32'!
renderTableOn: html
	self showCaption
		ifTrue: [ self renderTableCaptionOn: html ].
	self showSummary
		ifTrue: [ self renderTableSummaryOn: html ].
	html tag: 'thead' do: [
		self showHeader
			ifTrue: [ self renderTableHeadOn: html ] ].
	html tag: 'tfoot' do: [
		self showFooter
			ifTrue: [ self renderTableFootOn: html ].
		self showBatch
			ifTrue: [ self renderTableBatchOn: html ] ].
	html tag: 'tbody' do: [
		self showBody 
			ifTrue: [ self renderTableBodyOn: html ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 5/8/2005 20:32'!
renderTableSummaryOn: html
	html tag: 'summary' do: self tableSummary.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
rowFilter
	^ self backtrackedAt: #rowFilter ifAbsentPut: [ self defaultRowFilter ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
rowFilter: aBlock
	self backtrackedAt: #rowFilter put: aBlock.
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
rowPeriod
	^ self propertyAt: #rowPeriod ifAbsentPut: [ self defaultRowPeriod ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
rowPeriod: aNumber
	self propertyAt: #rowPeriod put: aNumber.! !

!MAReport methodsFor: 'private' stamp: 'lr 5/8/2005 20:32'!
rowStyleForNumber: aNumber
	^ self rowStyles 
		at: ((aNumber - 1 // self rowPeriod) \\ self rowStyles size) + 1
		ifAbsent: [ String new ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
rowStyles
	^ self propertyAt: #rowStyles ifAbsentPut: [ self defaultRowStyles ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
rowStyles: aCollection
	self propertyAt: #rowStyles put: aCollection.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 8/11/2005 17:18'!
rows
	"Return the rows of the receiver."

	^ rows ifNil: [ rows := Array new ].! !

!MAReport methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
rows: aCollection
	"Set the rows of the receiver."
	
	rows = aCollection 
		ifTrue: [ ^ self ].
	rows := aCollection.
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBatch
	^ self propertyAt: #showBatch ifAbsentPut: [ self defaultShowBatch ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBatchFirstLast
	^ self propertyAt: #showBatchFirstLast ifAbsentPut: [ self defaultShowBatchFirstLast ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBatchFirstLast: aBoolean
	self propertyAt: #showBatchFirstLast put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBatchPages
	^ self propertyAt: #showBatchPages ifAbsentPut: [ self defaultShowBatchPages ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBatchPages: aBoolean
	self propertyAt: #showBatchPages put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBatchPreviousNext
	^ self propertyAt: #showBatchPreviousNext ifAbsentPut: [ self defaultShowBatchPreviousNext ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBatchPreviousNext: aBoolean
	self propertyAt: #showBatchPreviousNext put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBody
	^ self propertyAt: #showBody ifAbsentPut: [ self defaultShowBody ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showBody: aBoolean
	self propertyAt: #showBody put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showCaption
	^ self propertyAt: #showCaption ifAbsentPut: [ self defaultShowCaption ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showCaption: aBoolean
	self propertyAt: #showCaption put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showFooter
	^ self propertyAt: #showFooter ifAbsentPut: [ self defaultShowFooter ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showHeader
	^ self propertyAt: #showHeader ifAbsentPut: [ self defaultShowHeader ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showSummary
	^ self propertyAt: #showSummary ifAbsentPut: [ self defaultShowSummary ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
showSummary: aBoolean
	self propertyAt: #showSummary put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortArrowDown
	^ self propertyAt: #sortArrowDown ifAbsentPut: [ self defaultSortArrowDown ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortArrowDown: aForm
	self propertyAt: #sortArrowDown put: aForm.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortArrowUp
	^ self propertyAt: #sortArrowUp ifAbsentPut: [ self defaultSortArrowUp ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortArrowUp: aForm
	self propertyAt: #sortArrowUp put: aForm.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortColumn
	^ self backtrackedAt: #sortColumn ifAbsentPut: [ self defaultSortColumn ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortColumn: aColumn
	self backtrackedAt: #sortColumn put: aColumn.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortEnabled
	^ self propertyAt: #sortEnabled ifAbsentPut: [ self defaultSortEnabled ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortEnabled: aBoolean
	self propertyAt: #sortEnabled put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortReversed
	^ self backtrackedAt: #sortReversed ifAbsentPut: [ self defaultSortReversed ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
sortReversed: aBoolean
	self backtrackedAt: #sortReversed put: aBoolean.! !

!MAReport methodsFor: 'private' stamp: 'lr 5/8/2005 20:32'!
sortRows: aCollection
	^ self isSorted
		ifFalse: [ aCollection ]
		ifTrue: [ self sortColumn sortRows: aCollection ].! !

!MAReport methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
sort: aColumn
	aColumn = self sortColumn
		ifTrue: [
			self sortReversed
				ifFalse: [ self sortReversed: true ]
				ifTrue: [ self sortColumn: nil; sortReversed: false ] ]
		ifFalse: [ self sortColumn: aColumn; sortReversed: false ].
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
tableCaption
	^ self propertyAt: #tableCaption ifAbsentPut: [ self defaultTableCaption ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
tableCaption: aString
	self propertyAt: #tableCaption put: aString.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
tableEmpty
	^ self propertyAt: #tableEmpty ifAbsentPut: [ self defaultTableEmpty ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
tableEmpty: aString
	self propertyAt: #tableEmpty put: aString.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
tableSummary
	^ self propertyAt: #tableSummary ifAbsentPut: [ self defaultTableSummary ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 5/8/2005 20:32'!
tableSummary: aString
	self propertyAt: #tableSummary put: aString.! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 5/8/2005 20:32'!
visible
	^ self showBatch
		ifFalse: [ self cache ]
		ifTrue: [
			self cache
				copyFrom: self batchStartIndex
				to: self batchEndIndex ].! !

!MATextDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultComponentClasses
	^ Array with: MATextAreaComponent.! !

!MATableDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultComponentClasses
	^ Array with: MATableComponent.! !

!MAMultipleErrors methodsFor: '*Magritte-Seaside-rendering' stamp: 'lr 9/23/2005 11:50'!
renderOn: html
	html unorderedList: [
		self collection do: [ :each |
			html listItem: each ] ].! !

!MAFileDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultComponentClasses
	^ Array with: MAFileUploadComponent.! !

!MAReportContainer class methodsFor: '*Magritte-Seaside' stamp: 'lr 5/8/2005 20:34'!
defaultComponentClasses
	^ Array with: MAReportComponent.! !

!MAOneToOneRelationDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 10/19/2005 23:05'!
defaultComponentClasses
	^ Array with: MAOneToOneComponent.! !

!MAPasswordDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 9/23/2005 11:32'!
defaultComponentClasses
	^ Array with: MATextPasswordComponent with: MATextInputComponent.! !

!MAStringDescription class methodsFor: '*Magritte-Seaside-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultComponentClasses
	^ Array with: MATextInputComponent.! !
